# class Gem::Resolver::Molinillo::Resolver

This class encapsulates a dependency resolver. The resolver is responsible for determining which set of dependencies to activate, with feedback from the {#specification_provider}

### Attributes

resolver_ui[R]

@return [UI] the `UI` module used to communicate back to the user

    during the resolution process

specification_provider[R]

@return [SpecificationProvider] the specification provider used

    in the resolution process

### Public Class Methods

new(specification_provider, resolver_ui) click to toggle source

Initializes a new resolver. @param [SpecificationProvider] `specification_provider`

    see {#specification_provider}

@param [UI] `resolver_ui`

    see {#resolver_ui}

    # File lib/rubygems/resolver/molinillo/lib/molinillo/resolver.rb, line 27
    def initialize(specification_provider, resolver_ui)
      @specification_provider = specification_provider
      @resolver_ui = resolver_ui
    end

### Public Instance Methods

resolve(requested, base = DependencyGraph.new) click to toggle source

Resolves the requested dependencies into a {DependencyGraph}, locking to the base dependency graph (if specified) @param [Array] requested an array of ‘requested’ dependencies that the

    {#specification_provider} can understand

@param [DependencyGraph,nil] base the base dependency graph to which

    dependencies should be 'locked'

    # File lib/rubygems/resolver/molinillo/lib/molinillo/resolver.rb, line 38
    def resolve(requested, base = DependencyGraph.new)
      Resolution.new(specification_provider,
                     resolver_ui,
                     requested,
                     base).
        resolve
    end